//
// fraktal - visualization of Mandelbrot and Julia sets
// Copyright (C) 1999-2020  Joachim Reichel <joachim.reichel@posteo.de>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef FRAKTAL_GLWIDGET_H
#define FRAKTAL_GLWIDGET_H

#if defined( HAVE_GLEW)
#  include <GL/glew.h>
#endif // HAVE_GLEW

#include <QtWidgets/QOpenGLWidget>

class MainWindow;

class GLWidget : public QOpenGLWidget
{
Q_OBJECT

public:

    GLWidget( MainWindow* mainwindow, QWidget* parent);

protected:

    void initializeGL();
    void paintGL();
    void resizeGL( int w, int h);

    void mousePressEvent( QMouseEvent* e);
    void mouseMoveEvent( QMouseEvent* e);
    void mouseReleaseEvent( QMouseEvent* e);

    void keyReleaseEvent( QKeyEvent* e);

private:

    QPoint m_last;
    double m_px;
    double m_py;

    Qt::MouseButton m_button_state;

    MainWindow* m_mainwindow;

    int m_quality;
};

#endif // FRAKTAL_GLWIDGET_H
