//
// fraktal - visualization of Mandelbrot and Julia sets
// Copyright (C) 1999-2020  Joachim Reichel <joachim.reichel@posteo.de>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef FRAKTAL_SHADER_COMMON_H
#define FRAKTAL_SHADER_COMMON_H

#define g_compute_color_string "\
\
vec4 compute_color (float v) \
{ \
    float r; \
    float g; \
    float b; \
\
    if (v == 0.0) \
        { \
            r = g = b = 0.0; \
        } \
    else \
        { \
            v = v/200.0; \
            v = v - floor (v); \
\
            if (v < 0.25) \
                { \
                    float x = 4.0*v; \
                    r = x; \
                    g = x; \
                    b = 0.52 + 0.44*x; \
                } \
            else if (v < 0.5) \
                { \
                    float x = 4.0*v-1.0; \
                    r = 1.0; \
                    g = 1.0 - 0.29*x; \
                    b = 0.96 - 0.96*x; \
                } \
            else if (v < 0.75) \
                { \
                    float x = 4.0*v-2.0; \
                    r = 1.0 - 0.39*x; \
                    g = 0.71 - 0.71*x; \
                    b = 0.0; \
                } \
            else \
                { \
                    float x = 4.0*v-3.0; \
                    r = 0.61 - 0.61*x; \
                    g = 0.0; \
                    b = 0.52*x; \
                } \
\
        } \
    return vec4 (r, g, b, 1.0); \
} \
"

#endif // FRAKTAL_SHADER_COMMON_H
